#TEMPLATE(MdvTemplate,'MDV Template'),FAMILY('ABC')
#!====================================================================================================================
#CONTROL (MySButton, 'Button with posible select any control after accept'),WINDOW, MULTI
     CONTROLS
       BUTTON('mButton'),AT(,,45,14),USE(?mButton)
     END
#SHEET
  #TAB('General')
    #PROMPT('Select contol:',FROM(%Control)),%MyControl,REQ
    #PROMPT('Refresh window after select',CHECK),%MyRefreshA,DEFAULT(1),AT(10)
  #ENDTAB
#ENDSHEET
#!--------------------------------------------------------------------------------------------------------------------
#ATSTART
#DECLARE(%xControl)
#FOR (%Control), WHERE(%ControlInstance = %ActiveTemplateInstance)
  #IF (%ControlOriginal = '?mButton')
    #SET (%xControl, %Control)
  #ENDIF
#ENDFOR
#ENDAT
#!--------------------------------------------------------------------------------------------------------------------
#AT (%ControlEventHandling, %xControl, 'Accepted'), PRIORITY(5500)
#!     ..       ,
#! ,    .   2    ResetFromFile,
#!    ResetQueue(Reset:Queue)
#IF (%MyRefreshA = 1)
ThisWindow.Reset(TRUE)
#ENDIF
SELECT(%MyControl)
#ENDAT
#!======================================================================================================================
#CONTROL(SelectFile, ' '),DESCRIPTION(' '), MULTI, WINDOW, FIRST
     CONTROLS
       BUTTON(''),FLAT,ICON('FileSeek.ico'),AT(,,13,12),HLP('SelectFile'),TIP(' '),USE(?SelectFile)
     END
#DISPLAY ('Select a file')
#DISPLAY
#PROMPT (' :', @S60), %FileDialogHeader, REQ, DEFAULT(' ')
#PROMPT (': ', FIELD), %FileVar, REQ
#PROMPT (' :', @S100), %FileExtensions, REQ, DEFAULT(' |*.*')
#PROMPT ('  . ', CHECK), %DirSplit, DEFAULT(%TRUE),AT(10)
#BOXED  ('   ')
  #PROMPT (' ', CHECK), %SelectControlAfter, DEFAULT(%TRUE),AT(10)
  #ENABLE (%SelectControlAfter)
    #PROMPT(':',FROM(%Control)),%NeedSelectControl,REQ
  #ENDENABLE
#ENDBOXED

#LOCALDATA
LOC:TmpFileName       STRING(256)
#ENDLOCALDATA

#ATSTART
#DECLARE (%SelectFile)
#DECLARE (%PREF)
#SET (%PREF, %ActiveTemplateInstance)
#FOR (%Control), WHERE(%ControlInstance = %ActiveTemplateInstance)
#SET (%SelectFile, %Control)
#ENDFOR
#ENDAT
#AT (%ControlEventHandling, %SelectFile, 'Accepted')
#EMBED(%mdvSelectFileBefore, 'Select File Control'),%TemplateInstance,MAP(%TemplateInstance,%SelectFile), '1.Before Fileselect dialog'
IF FILEDIALOGA('%FileDialogHeader',LOC:TmpFileName,'%FileExtensions',FILE:KeepDir+FILE:NoError+FILE:LongName)
  %FileVar = LOC:TmpFileName
  #IF(%DirSplit)
  IF INSTRING(UPPER(LONGPATH()), UPPER(%FileVar), 1, 1) = 1
    %FileVar = '.' & SUB(%FileVar, LEN(CLIP(LONGPATH()))+1, 255)
  END
  #ENDIF
  DISPLAY(?%FileVar)
END
#EMBED(%mdvSelectFileAfter, 'Select File Control'),%TemplateInstance,MAP(%TemplateInstance,%SelectFile), '2.After Fileselect dialog'
#IF(%SelectControlAfter)
SELECT(%NeedSelectControl)
#ENDIF
#ENDAT
#!======================================================================================================================
#CONTROL(WizardControl, ' '),DESCRIPTION(' '), MULTI, WINDOW, FIRST
     CONTROLS
       BUTTON(''),ICON('GoBegin.ico'), AT(,,28,14),MSG('  '),TIP('  '),USE(?BtnGoBegin)
       BUTTON(''),ICON('Previons.ico'),AT(29,0,28,14),MSG('   '),TIP('   '),USE(?BtnPrev)
       BUTTON(''),ICON('Next.ico'),    AT(29,0,28,14),MSG(' '),TIP(' '),USE(?BtnNext)
       BUTTON(''),ICON('GoEnd.ico'),   AT(29,0,28,14),MSG('   '),TIP('   '),USE(?BtnGoEnd)
     END
#PROMPT('Sheet   :',FROM(%Control, UPPER(%ControlType)='SHEET')),%SheetControl,REQ
#PROMPT('    ', CHECK), %DisableWizardControl, DEFAULT(0), AT(10,)
#PROMPT(' Sheet ', CHECK), %NoSheetsWizardControl, DEFAULT(0), AT(10,)

#AT(%WindowManagerMethodCodeSection, 'Init', '(),BYTE'), LAST
  %SheetControl{PROP:Wizard} = TRUE
  #IF (%NoSheetsWizardControl)
  %SheetControl{PROP:NoSheet} = True
  #ENDIF

  #IF (%DisableWizardControl)
  DISABLE(?BtnGoBegin)
  DISABLE(?BtnPrev)
  ENABLE(?BtnNext)
  ENABLE(?BtnGoEnd)
  #ENDIF
#ENDAT
#AT(%ControlEventHandling,'?BtnGoBegin','Accepted')
  Select(%SheetControl,1)
  Post(EVENT:NewSelection,%SheetControl,,2)
  #IF (%DisableWizardControl)
  DISABLE(?BtnGoBegin)
  DISABLE(?BtnPrev)
  ENABLE(?BtnNext)
  ENABLE(?BtnGoEnd)
  #ENDIF
  DISPLAY()
#ENDAT
#AT(%ControlEventHandling,'?BtnPrev','Accepted')
  curp# = CHOICE(%SheetControl)
  IF curp# > 1 THEN
     Select(%SheetControl,curp#-1)
     Post(EVENT:NewSelection,%SheetControl,,2)
  END
  #IF (%DisableWizardControl)
  IF curp# <= 2 THEN
    DISABLE(?BtnGoBegin)
    DISABLE(?BtnPrev)
    ENABLE(?BtnNext)
    ENABLE(?BtnGoEnd)
  END
  #ENDIF
  DISPLAY()
#ENDAT
#AT(%ControlEventHandling,'?BtnNext','Accepted')
  curp# = CHOICE(%SheetControl)
  numtabs# = %SheetControl{PROP:NumTabs}
  IF curp# < numtabs# THEN
     Select(%SheetControl,curp#+1)
     Post(EVENT:NewSelection,%SheetControl,,2)
  END
  #IF (%DisableWizardControl)
  IF curp#+1 >= numtabs# THEN
    ENABLE(?BtnGoBegin)
    ENABLE(?BtnPrev)
    DISABLE(?BtnNext)
    DISABLE(?BtnGoEnd)
  END
  #ENDIF
  DISPLAY()
#ENDAT
#AT(%ControlEventHandling,'?BtnGoEnd','Accepted')
  numtabs# = %SheetControl{PROP:NumTabs}
  Select(%SheetControl,numtabs#)
  Post(EVENT:NewSelection,%SheetControl,,2)
  #IF (%DisableWizardControl)
  ENABLE(?BtnGoBegin)
  ENABLE(?BtnPrev)
  DISABLE(?BtnNext)
  DISABLE(?BtnGoEnd)
  #ENDIF
  DISPLAY()
#ENDAT
#!======================================================================================================================
#!======================================================================================================================
#EXTENSION(xSetListLineHeight,'    '),APPLICATION
#PROMPT(':',@N3),%xHeight,REQ,DEFAULT(10)
#AT(%WindowManagerMethodCodeSection,'Init','(),BYTE'), PRIORITY(8500),WHERE(%Window)
#FOR(%Control),WHERE(%ControlType = 'LIST' OR %ControlType = 'COMBO')
!      
%Control{PROP:LineHeight} = %xHeight
!  -------------------------------------
#ENDFOR
#ENDAT
#!======================================================================================================================
#EXTENSION(xChangeButtonCaption,'    '),PROCEDURE,MULTI
#PROMPT(':',FROM(%Control,%ControlType = 'BUTTON')),%xBtnToChange,REQ
#PROMPT(' :', @S30),%xBtnNewCaption,REQ
#PROMPT(':', DROP('|')), %xBtnTypeIf, DEFAULT('')
#BOXED(''), AT(,40), WHERE(%xBtnTypeIf='')
  #PROMPT ('', @S50), %xBtnCaptionExprecion, REQ, AT(,,180)
#ENDBOXED
#BOXED(''), AT(,40), WHERE(%xBtnTypeIf='')
  #PROMPT ('', FIELD), %xBtnCaptionVar, REQ, AT(,,180)
#ENDBOXED
#!                                                   PRIORITY(8500)
#AT(%WindowManagerMethodCodeSection,'Init','(),BYTE'), LAST,WHERE(%Window)
!    
#IF(%xBtnTypeIf='')
IF %xBtnCaptionExprecion THEN
  %xBtnToChange{PROP:TEXT} = '%xBtnNewCaption'
END
#ENDIF
#IF(%xBtnTypeIf='')
IF %xBtnCaptionVar = TRUE THEN
  %xBtnToChange{PROP:TEXT} = '%xBtnNewCaption'
END
#ENDIF
#ENDAT
#!======================================================================================================================
#!======================================================================================================================
#CODE(xDisEnaControl,'Disable or Enable Controls'), DESCRIPTION('Disable or Enable controls with condition')
  #PROMPT('Check with:', DROP('Expression|Variable')), %xDisEnaCheckType, DEFAULT('Expression')
  #BOXED(''), AT(,10), WHERE(%xDisEnaCheckType='Expression')
     #PROMPT('Expression:', TEXT), %xDisEnaCondition, REQ
  #ENDBOXED
  #BOXED(''), AT(,20), WHERE(%xDisEnaCheckType='Variable')
    #PROMPT('Variable:', FIELD), %xDisEnaVCondition, REQ
  #ENDBOXED
  #BUTTON('Edit as a marked list'),AT(10,67,120,14)
    #DISPLAY ('Selected Controls:')
    #PROMPT('&Select Control:',FROM(%Control)),%xDisEnaAllControls,MULTI('Select Control'),INLINE,UNIQUE,SELECTION('Select Control')
  #ENDBUTTON
  #BUTTON('Get Selected'),WHENACCEPTED(%MakeControlList()),AT(140,67,50,14)
  #ENDBUTTON
  #DISPLAY
  #BUTTON('Controls'), MULTI(%xDisEnaControls, %xDisEnaCName), INLINE, AT(,85)
    #PROMPT('Control:', CONTROL),%xDisEnaCName
  #ENDBUTTON
  #PROMPT('What do with controls:', DROP('Enable|Disable|Hide|UnHide')), %xDisEnaAction, DEFAULT('Disable'), AT(,195), PROMPTAT(,195)

#EMBED(%xDisEnaBefore,'Before xDisEnaControl'), %ActiveTemplateInstance
#IF(%xDisEnaCheckType='Expression')
IF %xDisEnaCondition THEN
#ELSE
IF %xDisEnaVCondition = TRUE THEN
#ENDIF
#IF(%xDisEnaAction = 'Disable')
  #FOR (%xDisEnaControls)
  Disable(%xDisEnaCName)
  #ENDFOR
#ENDIF
#IF(%xDisEnaAction = 'Enable')
  #FOR (%xDisEnaControls)
  Enable(%xDisEnaCName)
  #ENDFOR
#ENDIF
#IF(%xDisEnaAction = 'Hide')
  #FOR (%xDisEnaControls)
  Hide(%xDisEnaCName)
  #ENDFOR
#ENDIF
#IF(%xDisEnaAction = 'UnHide')
  #FOR (%xDisEnaControls)
  UnHide(%xDisEnaCName)
  #ENDFOR
#ENDIF
END
#EMBED(%xDisEnaAfter,'After xDisEnaControl'), %ActiveTemplateInstance
#!====================================================================================================================
#GROUP(%MakeControlList)
  #DECLARE(%ItmNum)
  #SET(%ItmNum, 0)
  #FOR(%xDisEnaControls)
    #SET(%ItmNum, %ItmNum+1)
  #ENDFOR

  #FOR(%xDisEnaControls),REVERSE
    #DELETE(%xDisEnaControls,%ItmNum)
    #SET(%ItmNum, %ItmNum-1)
  #ENDFOR

  #SET(%ItmNum, 0)
  #FOR(%xDisEnaAllControls)
    #SET(%ItmNum, %ItmNum+1)
    #ADD(%xDisEnaControls,%ItmNum)
    #SET(%xDisEnaCName, %xDisEnaAllControls)
  #ENDFOR
#RETURN
#!====================================================================================================================
